#define Move(x,y)	bufp += sprintf(bufp, "\033:%d;%dm", x, y)

#define Setdot(x,y)	bufp += sprintf(bufp, "\033:%d;%d;0p", x, y)
#define Clrdot(x,y)	bufp += sprintf(bufp, "\033:%d;%d;1p", x, y)
#define Invdot(x,y)	bufp += sprintf(bufp, "\033:%d;%d;2p", x, y)
#define Testdot(x,y)	bufp += sprintf(bufp, "\033:%d;%d;10p", x, y)
/* Svar: ESC : <x> ; <y> ; 11 ; <cno> p */

#define Line(x,y,patt)	bufp += sprintf(bufp, "\033:%d;%d;%d;1d", x, y, patt)
#define Unline(x,y,patt) bufp += sprintf(bufp, "\033:%d;%d;%d;0d", x, y, patt)
#define Invline(x,y)	bufp += sprintf(bufp, "\033:%d;%di", x, y)

#define Arc(x,y,len,patt) \
		bufp += sprintf(bufp, "\033:%d;%d;%d;%d;1a", x, y, len, patt)
#define Unarc(x,y,len,patt) \
		bufp += sprintf(bufp, "\033:%d;%d;%d;%d;0a", x, y, len, patt)
#define Invarc(x,y,len) \
		bufp += sprintf(bufp, "\033:%d;%d;%dI", x, y, len)

#define Fill(x,y,patt)	bufp += sprintf(bufp, "\033:%d;%d;%d;1f", x, y, patt)
#define Unfill(x,y,patt) bufp += sprintf(bufp, "\033:%d;%d;%d;0f", x, y, patt)
#define Circle(x,y,rad,patt) \
		bufp += sprintf(bufp, "\033:%d;%d;%d;%d;1c", x, y, rad, patt)
#define Uncircle(x,y,rad,patt) \
		bufp += sprintf(bufp, "\033:%d;%d;%d;%d;0d", x, y, rad, patt)
#define Paint(x,y,patt) \
		bufp += sprintf(bufp, "\033:%d;%d;%d;1d", x, y, patt)
#define Unpaint(x,y,patt) \
		bufp += sprintf(bufp, "\033:%d;%d;%d;0d", x, y, patt)

#define Copy(x1,y1,x2,y2,w,h) \
    bufp += sprintf(bufp, "\033:%d;%d;%d;%d;%d;%d;0r", x1, y1, x2, y2, w, h)
#define Copyinv(x1,y1,x2,y2,w,h) \
    bufp += sprintf(bufp, "\033:%d;%d;%d;%d;%d;%d;1r", x1, y1, x2, y2, w, h)

#define Pattern(patt,hmask,vmask,shift,op) \
    bufp += sprintf(bufp, "\033:%d;%d;%d;%d;%dR", patt,hmask,vmask,shift,op)

#define Cur_UL() bufp += sprintf(bufp, "\033:%d;%dm\033:0H", x, y)
#define Cur_LL() bufp += sprintf(bufp, "\033:%d;%dm\033:1H", x, y)
#define Cur_BL() bufp += sprintf(bufp, "\033:%d;%dm\033:2H", x, y)

#define Origo(x,y) bufp += sprintf(bufp, "\033:%d;%dO", x, y)
#define Reset()	bufp += sprintf(bufp, "\033:J")
#define Phase()	bufp += sprintf(bufp, "\033:2h")
#define Unphase() bufp += sprintf(bufp, "\033:2l")

/* Standard line patterns: */
#define LINE		0
#define DOTTED		1
#define DASH		2
#define	DOUBLE_DOT	4
#define	FEW_DOTS	8
#define LONG_DOTS	9
#define SEGMENT		11

/* Standard fill patterns: */
#define WHOLE		0
#define GREY		1
#define CHESS		2
#define	DOTS		3
#define LINED		6
#define RASTER		7
#define LIGHT_GREY	8
#define OPTIC		14
#define DASHES		15


