#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

main(argc, argv)
int argc;
char **argv;
{
    struct stat stbuf;
    int fd;
    char c;

    while (--argc) {
	++argv;
	if ((fd = open(*argv, O_RDONLY)) == -1)
	    printf("Can't open %s\n", *argv);
	else if (fstat(fd, &stbuf) == -1)
		printf("Can't stat %s\n", *argv);
	else if (lseek(fd, -1L, 2) == -1)
	    printf("Can't lseek on %s\n", *argv);
	else if (read(fd, &c, 1) != 1)
	    printf("Can't read from %s\n", *argv);
	else if (c != '\032')	/* ^Z */
	    printf("%s does not contain MS-DOS EOF\n", *argv);
	else if (chsize(fd, (long) (stbuf.st_size - 1)) == -1)
		printf("Can't change size of %s\n", *argv);
	close(fd);
    }
}
