#include <errno.h>
#include <dnix/DataBoard.h>

extern int errno ;
main()
{
	struct DBpaddr db;	/* deklaration av struktur enl .h-filen	*/
	int cs, retcode, data;
	char answer[40];

start:  printf("Card adress:");
        scanf("%d",&cs);			/* l{s en kortadress	*/

	retcode = DB_setup(&db,cs);		/* mappa in DB-portar	*/
	if (retcode != 0 ) {
		if (errno == EPERM) printf("Not superuser.\n");
		exit(0);
		}

	printf("DB_setup return code (hexadecimal):%x,cs=%x\n",retcode,cs);

	printf("inp=   %x\n",db.DBpa_inp);
	printf("stat=  %x\n",db.DBpa_stat);
	printf("opstat=%x\n",db.DBpa_opstat);
	printf("out=   %x\n",db.DBpa_out);
	printf("C1=    %x\n",db.DBpa_C1);
	printf("C2=    %x\n",db.DBpa_C2);
	printf("C3=    %x\n",db.DBpa_C3);
	printf("C4=    %x\n",db.DBpa_C4);

	while (1) {
	    printf("\nReset, Status, Input, Output, Card select, Quit: ");
	    scanf("%s", answer);
	    switch(uppercase(*answer)) {
		case 'R':
		    printf("Resetting card: ");
		    printf("%x\n", DB_C3(&db, 0));
		    break;
		case 'S':
		    printf("Card status = %x\n", DB_STAT(&db));
		    break;
		case 'I':
		    printf("Trying to input from card: ");
		    printf("Input: %x\n", DB_INP(&db));
		    break;
		case 'O':
		    printf("Output to card: ");
		    scanf("%d", &data);
		    printf("Outputting...\n");
		    DB_OUT(&db, data);
		    printf("Output done\n");
		    break;
		case 'C':
		    goto start;
		case 'Q':
		    exit(0);
		default:
		    printf("Bad command!\n");
		}
	    }		
}

uppercase(c)
char c;
{
    return((c >= 'a' && c <= '}') ? c - 'a' + 'A' : c);
}
