#include <stdio.h>

main(argc, argv)
int argc;
char **argv;
{
    char c;
    extern int optind;
    extern char *optarg;
    int errflg=0;

    while ((c = getopt(argc, argv, "abc:d:")) != EOF)
	switch (c) {
	    case 'a':
	    case 'b':
		putchar(c);
		putchar(' ');
		break;
	    case 'c':
	    case 'd':
		putchar(c);
		printf("%s ", optarg);
		break;
	    case '?':
		errflg++;
	    }
    putchar('\n');
    if (errflg) {
	fprintf(stderr, "usage: opt [-abcd]\n");
	exit(1);
	}
    for ( ; optind < argc; optind++)
	printf("%s\n", argv[optind]);
}
