#include <stdio.h>
#include <sys/types.h>
#include <time.h>
/*#include <math.h>*/
#include "/usr/hn/h/standard.h"

char *progname;

main(argc, argv)
int argc;
char **argv;
{
    progname = argv[0];
    printf("%d\n", phase_of_the_moon());
}

struct tm *getlt()
{
    time_t date, time();
    struct tm *localtime(), *tp;
    static struct tm t;

    time(&date);
    printf("yy mm dd:");
    scanf("%d %d %d", &(t.tm_year), &(t.tm_mon), &(t.tm_mday));
    t.tm_mon--;
    if (t.tm_year)
	return(&t);
    else {
	tp = localtime(&date);
	printf("%d %d %d\n", tp->tm_year, tp->tm_mon, tp->tm_mday);
	return(tp);
	}
}

static int day_in_year[] = {            /* days in year for each month  */
    -1, 30, 58, 89, 119, 150, 180, 211, 241, 272, 303, 333
};                                      /* note: Jan. 1 will equal zero */

phase_of_the_moon()			/* 0-7, with 0: new, 4: full */
{					/* moon period: 29.5306 days */
					/* year: 365.2422 days */
    register struct tm *lt = getlt();
    register int epact, diy, golden;

    diy = lt->tm_mday + day_in_year[lt->tm_mon];
    if ((lt->tm_mon > 1) && (lt->tm_year % 4 == 0))
	diy++;
    golden = (lt->tm_year % 19) + 1;
    epact = (11 * golden + 18) % 30;
    if ((epact == 25 && golden > 11) || epact == 24)
	epact++;

    return( ((( (diy + epact)*6 + 11) % 177) / 22) /*& 7*/ );
}

panic(text, arg)
char *text, *arg;
{
    fprintf(stderr, "%s: ", progname);
    fprintf(stderr, text, arg);
    putc('\n', stderr);
    exit(1);
}
